diff --git a/buildscripts/promote_silent_failures.py b/buildscripts/promote_silent_failures.py
index aa6a71d..57da8aa 100644
--- a/buildscripts/promote_silent_failures.py
+++ b/buildscripts/promote_silent_failures.py
@@ -6,8 +6,8 @@ Any test files with at least 2 executions in the report.json file that have a "s
 this script will change the outputted report to have a "fail" status instead.
 """
 
-from __future__ import absolute_import
-from __future__ import print_function
+
+
 
 import collections
 import json
diff --git a/buildscripts/pylinters.py b/buildscripts/pylinters.py
index 539979e..7c95baa 100755
--- a/buildscripts/pylinters.py
+++ b/buildscripts/pylinters.py
@@ -1,7 +1,7 @@
 #!/usr/bin/env python2
 """Extensible script to run one or more Python Linters across a subset of files in parallel."""
-from __future__ import absolute_import
-from __future__ import print_function
+
+
 
 import argparse
 import logging
diff --git a/buildscripts/remote_operations.py b/buildscripts/remote_operations.py
index e2436ec..6c122b7 100755
--- a/buildscripts/remote_operations.py
+++ b/buildscripts/remote_operations.py
@@ -2,7 +2,7 @@
 
 """Remote access utilities, via ssh & scp."""
 
-from __future__ import print_function
+
 
 import optparse
 import os
diff --git a/buildscripts/resmoke.py b/buildscripts/resmoke.py
index 1d5bc7b..c9e402f 100755
--- a/buildscripts/resmoke.py
+++ b/buildscripts/resmoke.py
@@ -1,10 +1,10 @@
-#!/usr/bin/env python
+#!/usr/bin/env python3
 
 """
 Command line utility for executing MongoDB tests of all kinds.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 import random
diff --git a/buildscripts/resmokeconfig/__init__.py b/buildscripts/resmokeconfig/__init__.py
index 37f5a88..95b29df 100644
--- a/buildscripts/resmokeconfig/__init__.py
+++ b/buildscripts/resmokeconfig/__init__.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import
+
 
 from .suites import NAMED_SUITES
 from .loggers import NAMED_LOGGERS
diff --git a/buildscripts/resmokeconfig/loggers/__init__.py b/buildscripts/resmokeconfig/loggers/__init__.py
index 6511d49..6af399b 100644
--- a/buildscripts/resmokeconfig/loggers/__init__.py
+++ b/buildscripts/resmokeconfig/loggers/__init__.py
@@ -3,7 +3,7 @@ Defines a mapping of shortened names for logger configuration files to
 their full path.
 """
 
-from __future__ import absolute_import
+
 
 import os
 import os.path
@@ -21,7 +21,7 @@ def _get_named_loggers():
     named_loggers = {}
 
     try:
-        (root, _dirs, files) = os.walk(dirname).next()
+        (root, _dirs, files) = next(os.walk(dirname))
         for filename in files:
             (short_name, ext) = os.path.splitext(filename)
             if ext in (".yml", ".yaml"):
diff --git a/buildscripts/resmokeconfig/suites/__init__.py b/buildscripts/resmokeconfig/suites/__init__.py
index e075dd2..d3d954e 100644
--- a/buildscripts/resmokeconfig/suites/__init__.py
+++ b/buildscripts/resmokeconfig/suites/__init__.py
@@ -3,7 +3,7 @@ Defines a mapping of shortened names for suite configuration files to
 their full path.
 """
 
-from __future__ import absolute_import
+
 
 import os
 import os.path
@@ -21,7 +21,7 @@ def _get_named_suites():
     named_suites = {}
 
     try:
-        (root, _dirs, files) = os.walk(dirname).next()
+        (root, _dirs, files) = next(os.walk(dirname))
         for filename in files:
             (short_name, ext) = os.path.splitext(filename)
             if ext in (".yml", ".yaml"):
diff --git a/buildscripts/resmokelib/__init__.py b/buildscripts/resmokelib/__init__.py
index d8019dc..7201222 100644
--- a/buildscripts/resmokelib/__init__.py
+++ b/buildscripts/resmokelib/__init__.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import
+
 
 from . import errors
 from . import logging
diff --git a/buildscripts/resmokelib/config.py b/buildscripts/resmokelib/config.py
index 1dcd7d7..4cb8e38 100644
--- a/buildscripts/resmokelib/config.py
+++ b/buildscripts/resmokelib/config.py
@@ -2,7 +2,7 @@
 Configuration options for resmoke.py.
 """
 
-from __future__ import absolute_import
+
 
 import collections
 import itertools
@@ -58,7 +58,7 @@ DEFAULTS = {
     "repeat": 1,
     "reportFailureStatus": "fail",
     "reportFile": None,
-    "seed": long(time.time() * 256),  # Taken from random.py code in Python 2.7.
+    "seed": int(time.time() * 256),  # Taken from random.py code in Python 2.7.
     "serviceExecutor": None,
     "shellReadMode": None,
     "shellWriteMode": None,
diff --git a/buildscripts/resmokelib/core/__init__.py b/buildscripts/resmokelib/core/__init__.py
index 29a19a5..38129d8 100644
--- a/buildscripts/resmokelib/core/__init__.py
+++ b/buildscripts/resmokelib/core/__init__.py
@@ -1,4 +1,4 @@
-from __future__ import absolute_import
+
 
 from . import process
 from . import programs
diff --git a/buildscripts/resmokelib/core/network.py b/buildscripts/resmokelib/core/network.py
index 396da4e..398ff5b 100644
--- a/buildscripts/resmokelib/core/network.py
+++ b/buildscripts/resmokelib/core/network.py
@@ -3,7 +3,7 @@ Class used to allocate ports for use by various mongod and mongos
 processes involved in running the tests.
 """
 
-from __future__ import absolute_import
+
 
 import collections
 import functools
diff --git a/buildscripts/resmokelib/core/pipe.py b/buildscripts/resmokelib/core/pipe.py
index bb08072..8a21e02 100644
--- a/buildscripts/resmokelib/core/pipe.py
+++ b/buildscripts/resmokelib/core/pipe.py
@@ -4,7 +4,7 @@ from the pipe buffer filling up and blocking the subprocess while it's
 being waited on.
 """
 
-from __future__ import absolute_import
+
 
 import threading
 
diff --git a/buildscripts/resmokelib/core/process.py b/buildscripts/resmokelib/core/process.py
index 03fb849..b331492 100644
--- a/buildscripts/resmokelib/core/process.py
+++ b/buildscripts/resmokelib/core/process.py
@@ -5,7 +5,7 @@ Uses job objects when running on Windows to ensure that all created
 processes are terminated.
 """
 
-from __future__ import absolute_import
+
 
 import atexit
 import logging
@@ -196,8 +196,8 @@ class Process(object):
                 finally:
                     win32api.CloseHandle(mongo_signal_handle)
 
-                print "Failed to cleanly exit the program, calling TerminateProcess() on PID: " +\
-                    str(self._process.pid)
+                print("Failed to cleanly exit the program, calling TerminateProcess() on PID: " +\
+                    str(self._process.pid))
 
             # Adapted from implementation of Popen.terminate() in subprocess.py of Python 2.7
             # because earlier versions do not catch exceptions.
diff --git a/buildscripts/resmokelib/core/programs.py b/buildscripts/resmokelib/core/programs.py
index 097e0d7..eb7a4e3 100644
--- a/buildscripts/resmokelib/core/programs.py
+++ b/buildscripts/resmokelib/core/programs.py
@@ -4,7 +4,7 @@ Utility functions to create MongoDB processes.
 Handles all the nitty-gritty parameter conversion.
 """
 
-from __future__ import absolute_import
+
 
 import json
 import os
diff --git a/buildscripts/resmokelib/logging/__init__.py b/buildscripts/resmokelib/logging/__init__.py
index 816a620..780cd2e 100644
--- a/buildscripts/resmokelib/logging/__init__.py
+++ b/buildscripts/resmokelib/logging/__init__.py
@@ -2,7 +2,7 @@
 Extension to the logging package to support buildlogger.
 """
 
-from __future__ import absolute_import
+
 
 # Alias the built-in logging.Logger class for type checking arguments. Those interested in
 # constructing a new Logger instance should use the loggers.new_logger() function instead.
diff --git a/buildscripts/resmokelib/logging/buildlogger.py b/buildscripts/resmokelib/logging/buildlogger.py
index a577d64..a38cab2 100644
--- a/buildscripts/resmokelib/logging/buildlogger.py
+++ b/buildscripts/resmokelib/logging/buildlogger.py
@@ -2,7 +2,7 @@
 Defines handlers for communicating with a buildlogger server.
 """
 
-from __future__ import absolute_import
+
 
 import functools
 
@@ -205,7 +205,7 @@ class BuildloggerServer(object):
     def __init__(self):
         tmp_globals = {}
         self.config = {}
-        execfile(_BUILDLOGGER_CONFIG, tmp_globals, self.config)
+        exec(compile(open(_BUILDLOGGER_CONFIG).read(), _BUILDLOGGER_CONFIG, 'exec'), tmp_globals, self.config)
 
         # Rename "slavename" to "username" if present.
         if "slavename" in self.config and "username" not in self.config:
diff --git a/buildscripts/resmokelib/logging/flush.py b/buildscripts/resmokelib/logging/flush.py
index 18c3a37..d3441f3 100644
--- a/buildscripts/resmokelib/logging/flush.py
+++ b/buildscripts/resmokelib/logging/flush.py
@@ -3,7 +3,7 @@ Manages a thread responsible for periodically calling flush() on
 logging.Handler instances used to send logs to buildlogger.
 """
 
-from __future__ import absolute_import
+
 
 import logging
 import threading
diff --git a/buildscripts/resmokelib/logging/formatters.py b/buildscripts/resmokelib/logging/formatters.py
index 4cc36da..a0fbc71 100644
--- a/buildscripts/resmokelib/logging/formatters.py
+++ b/buildscripts/resmokelib/logging/formatters.py
@@ -2,7 +2,7 @@
 Custom formatters for the logging handlers.
 """
 
-from __future__ import absolute_import
+
 
 import logging
 import sys
diff --git a/buildscripts/resmokelib/logging/handlers.py b/buildscripts/resmokelib/logging/handlers.py
index 8a0bca2..68aeccb 100644
--- a/buildscripts/resmokelib/logging/handlers.py
+++ b/buildscripts/resmokelib/logging/handlers.py
@@ -3,7 +3,7 @@ Additional handlers that are used as the base classes of the buildlogger
 handler.
 """
 
-from __future__ import absolute_import
+
 
 import json
 import logging
diff --git a/buildscripts/resmokelib/logging/loggers.py b/buildscripts/resmokelib/logging/loggers.py
index 821595b..cd88dc8 100644
--- a/buildscripts/resmokelib/logging/loggers.py
+++ b/buildscripts/resmokelib/logging/loggers.py
@@ -2,7 +2,7 @@
 Module to hold the logger instances themselves.
 """
 
-from __future__ import absolute_import
+
 
 import logging
 import sys
diff --git a/buildscripts/resmokelib/parser.py b/buildscripts/resmokelib/parser.py
index ed11001..c58524d 100644
--- a/buildscripts/resmokelib/parser.py
+++ b/buildscripts/resmokelib/parser.py
@@ -2,7 +2,7 @@
 Parser for command line arguments.
 """
 
-from __future__ import absolute_import
+
 
 import collections
 import os
diff --git a/buildscripts/resmokelib/reportfile.py b/buildscripts/resmokelib/reportfile.py
index 7dcf562..457c8e6 100644
--- a/buildscripts/resmokelib/reportfile.py
+++ b/buildscripts/resmokelib/reportfile.py
@@ -2,7 +2,7 @@
 Manages interactions with the report.json file.
 """
 
-from __future__ import absolute_import
+
 
 import json
 
diff --git a/buildscripts/resmokelib/selector.py b/buildscripts/resmokelib/selector.py
index 3fff181..519a1fc 100644
--- a/buildscripts/resmokelib/selector.py
+++ b/buildscripts/resmokelib/selector.py
@@ -5,7 +5,7 @@ Defines filtering rules for what tests to include in a suite depending
 on whether they apply to C++ unit tests, dbtests, or JS tests.
 """
 
-from __future__ import absolute_import
+
 
 import collections
 import errno
@@ -66,7 +66,7 @@ class TestFileExplorer(object):
             A list of paths as a list(str).
         """
         tests = []
-        with open(root_file_path, "rb") as filep:
+        with open(root_file_path, "r") as filep:
             for test_path in filep:
                 test_path = test_path.strip()
                 tests.append(test_path)
@@ -294,7 +294,7 @@ def make_expression(conf):
     elif isinstance(conf, dict):
         if len(conf) != 1:
             raise ValueError("Tag matching expressions should only contain one key")
-        key = conf.keys()[0]
+        key = next(iter(conf.keys()))
         value = conf[key]
         if key == "$allOf":
             return _AllOfExpression(_make_expression_list(value))
diff --git a/buildscripts/resmokelib/sighandler.py b/buildscripts/resmokelib/sighandler.py
index 7058b62..499fad7 100644
--- a/buildscripts/resmokelib/sighandler.py
+++ b/buildscripts/resmokelib/sighandler.py
@@ -2,7 +2,7 @@
 Utility to support asynchronously signaling the current process.
 """
 
-from __future__ import absolute_import
+
 
 import atexit
 import os
diff --git a/buildscripts/resmokelib/testing/__init__.py b/buildscripts/resmokelib/testing/__init__.py
index e4acff0..4967d78 100644
--- a/buildscripts/resmokelib/testing/__init__.py
+++ b/buildscripts/resmokelib/testing/__init__.py
@@ -3,7 +3,7 @@ Extension to the unittest package to support buildlogger and parallel
 test execution.
 """
 
-from __future__ import absolute_import
+
 
 from . import executor
 from . import suite
diff --git a/buildscripts/resmokelib/testing/executor.py b/buildscripts/resmokelib/testing/executor.py
index cc66556..4ea8f22 100644
--- a/buildscripts/resmokelib/testing/executor.py
+++ b/buildscripts/resmokelib/testing/executor.py
@@ -2,7 +2,7 @@
 Driver of the test execution framework.
 """
 
-from __future__ import absolute_import
+
 
 import threading
 import time
@@ -64,7 +64,7 @@ class TestSuiteExecutor(object):
             jobs_to_start = num_tests
 
         # Must be done after getting buildlogger configuration.
-        self._jobs = [self._make_job(job_num) for job_num in xrange(jobs_to_start)]
+        self._jobs = [self._make_job(job_num) for job_num in range(jobs_to_start)]
 
     def run(self):
         """
@@ -290,7 +290,7 @@ class TestSuiteExecutor(object):
             queue.put(test_case)
 
         # Add sentinel value for each job to indicate when there are no more items to process.
-        for _ in xrange(len(self._jobs)):
+        for _ in range(len(self._jobs)):
             queue.put(None)
 
         return queue
diff --git a/buildscripts/resmokelib/testing/fixtures/__init__.py b/buildscripts/resmokelib/testing/fixtures/__init__.py
index d8c3d8a..31183eb 100644
--- a/buildscripts/resmokelib/testing/fixtures/__init__.py
+++ b/buildscripts/resmokelib/testing/fixtures/__init__.py
@@ -2,7 +2,7 @@
 Fixtures for executing JSTests against.
 """
 
-from __future__ import absolute_import
+
 
 from .interface import NoOpFixture as _NoOpFixture
 from .interface import make_fixture
diff --git a/buildscripts/resmokelib/testing/fixtures/interface.py b/buildscripts/resmokelib/testing/fixtures/interface.py
index 6dffa24..4baf2cf 100644
--- a/buildscripts/resmokelib/testing/fixtures/interface.py
+++ b/buildscripts/resmokelib/testing/fixtures/interface.py
@@ -2,7 +2,7 @@
 Interface of the different fixtures for executing JSTests against.
 """
 
-from __future__ import absolute_import
+
 
 import time
 
@@ -27,13 +27,11 @@ def make_fixture(class_name, *args, **kwargs):
     return _FIXTURES[class_name](*args, **kwargs)
 
 
-class Fixture(object):
+class Fixture(object, metaclass=registry.make_registry_metaclass(_FIXTURES)):
     """
     Base class for all fixtures.
     """
 
-    __metaclass__ = registry.make_registry_metaclass(_FIXTURES)
-
     # We explicitly set the 'REGISTERED_NAME' attribute so that PyLint realizes that the attribute
     # is defined for all subclasses of Fixture.
     REGISTERED_NAME = "Fixture"
diff --git a/buildscripts/resmokelib/testing/fixtures/masterslave.py b/buildscripts/resmokelib/testing/fixtures/masterslave.py
index 96b4ec5..f354a44 100644
--- a/buildscripts/resmokelib/testing/fixtures/masterslave.py
+++ b/buildscripts/resmokelib/testing/fixtures/masterslave.py
@@ -2,7 +2,7 @@
 Master/slave fixture for executing JSTests against.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 
diff --git a/buildscripts/resmokelib/testing/fixtures/replicaset.py b/buildscripts/resmokelib/testing/fixtures/replicaset.py
index 025ce25..7f458f0 100644
--- a/buildscripts/resmokelib/testing/fixtures/replicaset.py
+++ b/buildscripts/resmokelib/testing/fixtures/replicaset.py
@@ -2,7 +2,7 @@
 Replica set fixture for executing JSTests against.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 import time
@@ -75,7 +75,7 @@ class ReplicaSetFixture(interface.ReplFixture):
         self.replset_name = self.mongod_options.get("replSet", "rs")
 
         if not self.nodes:
-            for i in xrange(self.num_nodes):
+            for i in range(self.num_nodes):
                 node = self._new_mongod(i, self.replset_name)
                 self.nodes.append(node)
 
diff --git a/buildscripts/resmokelib/testing/fixtures/shardedcluster.py b/buildscripts/resmokelib/testing/fixtures/shardedcluster.py
index 4f90d16..d5610ed 100644
--- a/buildscripts/resmokelib/testing/fixtures/shardedcluster.py
+++ b/buildscripts/resmokelib/testing/fixtures/shardedcluster.py
@@ -2,7 +2,7 @@
 Sharded cluster fixture for executing JSTests against.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 import time
@@ -85,7 +85,7 @@ class ShardedClusterFixture(interface.Fixture):
             self.configsvr.setup()
 
         if not self.shards:
-            for i in xrange(self.num_shards):
+            for i in range(self.num_shards):
                 if self.num_rs_nodes_per_shard is None:
                     shard = self._new_standalone_shard(i)
                 elif isinstance(self.num_rs_nodes_per_shard, int):
diff --git a/buildscripts/resmokelib/testing/fixtures/standalone.py b/buildscripts/resmokelib/testing/fixtures/standalone.py
index 1fd8a80..7616037 100644
--- a/buildscripts/resmokelib/testing/fixtures/standalone.py
+++ b/buildscripts/resmokelib/testing/fixtures/standalone.py
@@ -2,7 +2,7 @@
 Standalone mongod fixture for executing JSTests against.
 """
 
-from __future__ import absolute_import
+
 
 import os
 import os.path
diff --git a/buildscripts/resmokelib/testing/hooks/__init__.py b/buildscripts/resmokelib/testing/hooks/__init__.py
index f1d6ec5..ec063fe 100644
--- a/buildscripts/resmokelib/testing/hooks/__init__.py
+++ b/buildscripts/resmokelib/testing/hooks/__init__.py
@@ -4,7 +4,7 @@ by allowing special code to be executed before or after each test, and
 before or after each suite.
 """
 
-from __future__ import absolute_import
+
 
 from .interface import make_custom_behavior
 from ...utils import autoloader as _autoloader
diff --git a/buildscripts/resmokelib/testing/hooks/cleanup.py b/buildscripts/resmokelib/testing/hooks/cleanup.py
index f19b4bc..4590f0f 100644
--- a/buildscripts/resmokelib/testing/hooks/cleanup.py
+++ b/buildscripts/resmokelib/testing/hooks/cleanup.py
@@ -2,7 +2,7 @@
 Testing hook for cleaning up data files created by the fixture.
 """
 
-from __future__ import absolute_import
+
 
 import os
 
diff --git a/buildscripts/resmokelib/testing/hooks/dbhash.py b/buildscripts/resmokelib/testing/hooks/dbhash.py
index 02b7b18..f50705b 100644
--- a/buildscripts/resmokelib/testing/hooks/dbhash.py
+++ b/buildscripts/resmokelib/testing/hooks/dbhash.py
@@ -2,7 +2,7 @@
 Testing hook for verifying data consistency across a replica set.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 
diff --git a/buildscripts/resmokelib/testing/hooks/initialsync.py b/buildscripts/resmokelib/testing/hooks/initialsync.py
index 20b422b..01c5aa1 100644
--- a/buildscripts/resmokelib/testing/hooks/initialsync.py
+++ b/buildscripts/resmokelib/testing/hooks/initialsync.py
@@ -2,7 +2,7 @@
 Testing hook for verifying correctness of initial sync.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 import random
diff --git a/buildscripts/resmokelib/testing/hooks/interface.py b/buildscripts/resmokelib/testing/hooks/interface.py
index 6ca4ae7..757ee08 100644
--- a/buildscripts/resmokelib/testing/hooks/interface.py
+++ b/buildscripts/resmokelib/testing/hooks/interface.py
@@ -2,7 +2,7 @@
 Interface for customizing the behavior of a test fixture.
 """
 
-from __future__ import absolute_import
+
 
 from ... import logging
 from ...utils import registry
@@ -22,13 +22,11 @@ def make_custom_behavior(class_name, *args, **kwargs):
     return _HOOKS[class_name](*args, **kwargs)
 
 
-class CustomBehavior(object):
+class CustomBehavior(object, metaclass=registry.make_registry_metaclass(_HOOKS)):
     """
     The common interface all CustomBehaviors will inherit from.
     """
 
-    __metaclass__ = registry.make_registry_metaclass(_HOOKS)
-
     REGISTERED_NAME = registry.LEAVE_UNREGISTERED
 
     @staticmethod
diff --git a/buildscripts/resmokelib/testing/hooks/jsfile.py b/buildscripts/resmokelib/testing/hooks/jsfile.py
index 510ad7a..bf78218 100644
--- a/buildscripts/resmokelib/testing/hooks/jsfile.py
+++ b/buildscripts/resmokelib/testing/hooks/jsfile.py
@@ -3,7 +3,7 @@ Interface for customizing the behavior of a test fixture by executing a
 JavaScript file.
 """
 
-from __future__ import absolute_import
+
 
 import sys
 
diff --git a/buildscripts/resmokelib/testing/hooks/oplog.py b/buildscripts/resmokelib/testing/hooks/oplog.py
index 62fa240..628828e 100644
--- a/buildscripts/resmokelib/testing/hooks/oplog.py
+++ b/buildscripts/resmokelib/testing/hooks/oplog.py
@@ -3,7 +3,7 @@ Testing hook for verifying members of a replica set have matching
 oplogs.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 
diff --git a/buildscripts/resmokelib/testing/hooks/periodic_kill_secondaries.py b/buildscripts/resmokelib/testing/hooks/periodic_kill_secondaries.py
index ecbb396..7787f9a 100644
--- a/buildscripts/resmokelib/testing/hooks/periodic_kill_secondaries.py
+++ b/buildscripts/resmokelib/testing/hooks/periodic_kill_secondaries.py
@@ -3,7 +3,7 @@ Testing hook for verifying correctness of a secondary's behavior during
 an unclean shutdown.
 """
 
-from __future__ import absolute_import
+
 
 import sys
 import time
diff --git a/buildscripts/resmokelib/testing/hooks/stepdown.py b/buildscripts/resmokelib/testing/hooks/stepdown.py
index 46f91ab..ed6f7d5 100644
--- a/buildscripts/resmokelib/testing/hooks/stepdown.py
+++ b/buildscripts/resmokelib/testing/hooks/stepdown.py
@@ -1,7 +1,7 @@
 """
 Testing hook that periodically makes the primary of a replica set step down.
 """
-from __future__ import absolute_import
+
 
 import sys
 import time
diff --git a/buildscripts/resmokelib/testing/hooks/validate.py b/buildscripts/resmokelib/testing/hooks/validate.py
index 367b905..e30e5d3 100644
--- a/buildscripts/resmokelib/testing/hooks/validate.py
+++ b/buildscripts/resmokelib/testing/hooks/validate.py
@@ -3,7 +3,7 @@ Testing hook for verifying the consistency and integrity of collection
 and index data.
 """
 
-from __future__ import absolute_import
+
 
 import os.path
 
diff --git a/buildscripts/resmokelib/testing/job.py b/buildscripts/resmokelib/testing/job.py
index 9841c07..4306e95 100644
--- a/buildscripts/resmokelib/testing/job.py
+++ b/buildscripts/resmokelib/testing/job.py
@@ -3,7 +3,7 @@ Enables supports for running tests simultaneously by processing them
 from a multi-consumer queue.
 """
 
-from __future__ import absolute_import
+
 
 import sys
 
diff --git a/buildscripts/resmokelib/testing/report.py b/buildscripts/resmokelib/testing/report.py
index 71a8e5e..36817bf 100644
--- a/buildscripts/resmokelib/testing/report.py
+++ b/buildscripts/resmokelib/testing/report.py
@@ -3,7 +3,7 @@ Extension to the unittest.TestResult to support additional test status
 and timing information for the report.json file.
 """
 
-from __future__ import absolute_import
+
 
 import copy
 import threading
diff --git a/buildscripts/resmokelib/testing/suite.py b/buildscripts/resmokelib/testing/suite.py
index 132a2d7..0470994 100644
--- a/buildscripts/resmokelib/testing/suite.py
+++ b/buildscripts/resmokelib/testing/suite.py
@@ -3,7 +3,7 @@ Holder for the (test kind, list of tests) pair with additional metadata about wh
 execute.
 """
 
-from __future__ import absolute_import
+
 
 import itertools
 import threading
@@ -262,7 +262,7 @@ class Suite(object):
         sb.append("Executed %d times in %0.2f seconds:" % (num_iterations, total_time_taken))
 
         combined_summary = _summary.Summary(0, 0.0, 0, 0, 0, 0)
-        for iteration in xrange(num_iterations):
+        for iteration in range(num_iterations):
             # Summarize each execution as a bulleted list of results.
             bulleter_sb = []
             summary = self._summarize_report(
diff --git a/buildscripts/resmokelib/testing/summary.py b/buildscripts/resmokelib/testing/summary.py
index bb44472..5e13941 100644
--- a/buildscripts/resmokelib/testing/summary.py
+++ b/buildscripts/resmokelib/testing/summary.py
@@ -2,7 +2,7 @@
 Holder for summary information about a test suite.
 """
 
-from __future__ import absolute_import
+
 
 import collections
 
@@ -17,6 +17,6 @@ def combine(summary1, summary2):
     Returns a summary representing the sum of 'summary1' and 'summary2'.
     """
     args = []
-    for i in xrange(len(Summary._fields)):
+    for i in range(len(Summary._fields)):
         args.append(summary1[i] + summary2[i])
     return Summary._make(args)
diff --git a/buildscripts/resmokelib/testing/testcases/__init__.py b/buildscripts/resmokelib/testing/testcases/__init__.py
index 047b5c1..90015bf 100644
--- a/buildscripts/resmokelib/testing/testcases/__init__.py
+++ b/buildscripts/resmokelib/testing/testcases/__init__.py
@@ -2,7 +2,7 @@
 Package containing subclasses of unittest.TestCase.
 """
 
-from __future__ import absolute_import
+
 
 from .interface import make_test_case
 from ...utils import autoloader as _autoloader
diff --git a/buildscripts/resmokelib/testing/testcases/cpp_integration_test.py b/buildscripts/resmokelib/testing/testcases/cpp_integration_test.py
index 12849cc..0f2996b 100644
--- a/buildscripts/resmokelib/testing/testcases/cpp_integration_test.py
+++ b/buildscripts/resmokelib/testing/testcases/cpp_integration_test.py
@@ -2,7 +2,7 @@
 unittest.TestCase for C++ integration tests.
 """
 
-from __future__ import absolute_import
+
 
 from . import interface
 from ... import core
diff --git a/buildscripts/resmokelib/testing/testcases/cpp_unittest.py b/buildscripts/resmokelib/testing/testcases/cpp_unittest.py
index b11ab34..fd7723c 100644
--- a/buildscripts/resmokelib/testing/testcases/cpp_unittest.py
+++ b/buildscripts/resmokelib/testing/testcases/cpp_unittest.py
@@ -2,7 +2,7 @@
 unittest.TestCase for C++ unit tests.
 """
 
-from __future__ import absolute_import
+
 
 from . import interface
 from ... import core
diff --git a/buildscripts/resmokelib/testing/testcases/dbtest.py b/buildscripts/resmokelib/testing/testcases/dbtest.py
index 13deac9..53333fb 100644
--- a/buildscripts/resmokelib/testing/testcases/dbtest.py
+++ b/buildscripts/resmokelib/testing/testcases/dbtest.py
@@ -2,7 +2,7 @@
 unittest.TestCase for dbtests.
 """
 
-from __future__ import absolute_import
+
 
 import os
 import os.path
diff --git a/buildscripts/resmokelib/testing/testcases/interface.py b/buildscripts/resmokelib/testing/testcases/interface.py
index be7f14a..97d1ab9 100644
--- a/buildscripts/resmokelib/testing/testcases/interface.py
+++ b/buildscripts/resmokelib/testing/testcases/interface.py
@@ -3,7 +3,7 @@ Subclass of unittest.TestCase with helpers for spawning a separate
 process to perform the actual test case.
 """
 
-from __future__ import absolute_import
+
 
 import os
 import os.path
@@ -27,13 +27,11 @@ def make_test_case(test_kind, *args, **kwargs):
     return _TEST_CASES[test_kind](*args, **kwargs)
 
 
-class TestCase(unittest.TestCase):
+class TestCase(unittest.TestCase, metaclass=registry.make_registry_metaclass(_TEST_CASES)):
     """
     A test case to execute.
     """
 
-    __metaclass__ = registry.make_registry_metaclass(_TEST_CASES)
-
     REGISTERED_NAME = registry.LEAVE_UNREGISTERED
 
     def __init__(self, logger, test_kind, test_name):
@@ -46,10 +44,10 @@ class TestCase(unittest.TestCase):
         if not isinstance(logger, logging.Logger):
             raise TypeError("logger must be a Logger instance")
 
-        if not isinstance(test_kind, basestring):
+        if not isinstance(test_kind, str):
             raise TypeError("test_kind must be a string")
 
-        if not isinstance(test_name, basestring):
+        if not isinstance(test_name, str):
             raise TypeError("test_name must be a string")
 
         # When the TestCase is created by the TestSuiteExecutor (through a call to make_test_case())
diff --git a/buildscripts/resmokelib/testing/testcases/json_schema_test.py b/buildscripts/resmokelib/testing/testcases/json_schema_test.py
index 51a8daa..335a83c 100644
--- a/buildscripts/resmokelib/testing/testcases/json_schema_test.py
+++ b/buildscripts/resmokelib/testing/testcases/json_schema_test.py
@@ -2,7 +2,7 @@
 unittest.TestCase for JSON Schema tests.
 """
 
-from __future__ import absolute_import
+
 
 from . import interface
 from ... import config
diff --git a/buildscripts/resmokelib/testing/testcases/jstest.py b/buildscripts/resmokelib/testing/testcases/jstest.py
index adb2828..35ee346 100644
--- a/buildscripts/resmokelib/testing/testcases/jstest.py
+++ b/buildscripts/resmokelib/testing/testcases/jstest.py
@@ -2,7 +2,7 @@
 unittest.TestCase for JavaScript tests.
 """
 
-from __future__ import absolute_import
+
 
 import os
 import os.path
diff --git a/buildscripts/resmokelib/testing/testcases/mongos_test.py b/buildscripts/resmokelib/testing/testcases/mongos_test.py
index 4a2fc0d..0699442 100644
--- a/buildscripts/resmokelib/testing/testcases/mongos_test.py
+++ b/buildscripts/resmokelib/testing/testcases/mongos_test.py
@@ -2,7 +2,7 @@
 unittest.TestCase for mongos --test.
 """
 
-from __future__ import absolute_import
+
 
 from . import interface
 from ... import config
diff --git a/buildscripts/resmokelib/utils/__init__.py b/buildscripts/resmokelib/utils/__init__.py
index fa782f3..9beb652 100644
--- a/buildscripts/resmokelib/utils/__init__.py
+++ b/buildscripts/resmokelib/utils/__init__.py
@@ -2,8 +2,8 @@
 Helper functions.
 """
 
-from __future__ import absolute_import
-from __future__ import print_function
+
+
 
 import contextlib
 import os.path
@@ -43,14 +43,14 @@ def is_string_list(lst):
     """
     Returns true if 'lst' is a list of strings, and false otherwise.
     """
-    return isinstance(lst, list) and all(isinstance(x, basestring) for x in lst)
+    return isinstance(lst, list) and all(isinstance(x, str) for x in lst)
 
 
 def is_string_set(value):
     """
     Returns true if 'value' is a set of strings, and false otherwise.
     """
-    return isinstance(value, set) and all(isinstance(x, basestring) for x in value)
+    return isinstance(value, set) and all(isinstance(x, str) for x in value)
 
 
 def is_js_file(filename):
diff --git a/buildscripts/resmokelib/utils/autoloader.py b/buildscripts/resmokelib/utils/autoloader.py
index 1ac58ab..6f3e341 100644
--- a/buildscripts/resmokelib/utils/autoloader.py
+++ b/buildscripts/resmokelib/utils/autoloader.py
@@ -2,7 +2,7 @@
 Utility for loading all modules within a package.
 """
 
-from __future__ import absolute_import
+
 
 import importlib
 import pkgutil
diff --git a/buildscripts/resmokelib/utils/globstar.py b/buildscripts/resmokelib/utils/globstar.py
index 644ebfe..e9e3509 100644
--- a/buildscripts/resmokelib/utils/globstar.py
+++ b/buildscripts/resmokelib/utils/globstar.py
@@ -2,7 +2,7 @@
 Filename globbing utility.
 """
 
-from __future__ import absolute_import
+
 
 import glob as _glob
 import os
@@ -145,7 +145,7 @@ def _list_dir(pathname):
     """
 
     try:
-        (_root, dirs, files) = os.walk(pathname).next()
+        (_root, dirs, files) = next(os.walk(pathname))
         return (dirs, files)
     except StopIteration:
         return None  # 'pathname' directory does not exist
